---
    - name: Creating Kubernetes auth method 
      hashivault_auth_method:
        url: "{{ vault_url }}"
        username: "{{ vault_username }}"
        password: "{{ vault_password }}"
        authtype: "userpass"
        method_type: kubernetes
        mount_point: "{{ cluster_name }}"
        state: "enabled"

    - name: Creating ServiceAccount vault-auth-delegator in kube-system
      k8s:
        kubeconfig: "{{ dest_kubeconfig }}"
        verify_ssl: no
        definition: "{{ lookup('file', './serviceaccount.yaml') }}"
        state: present

    - name: Creating ClusterRoleBinding vault-auth-delegator
      k8s:
        kubeconfig: "{{ dest_kubeconfig }}"
        verify_ssl: no
        definition: "{{ lookup('file', './crb.yaml') }}"
        state: present

    - name: Getting status
      shell: 'oc status'
      register: status
      
    - name: show status
      debug:
        msg: "{{ cluster_name }}"
      
    - name: Getting ServiceAccount token
      shell: 'oc serviceaccounts get-token vault-auth-delegator -n kube-system'
      register: auth_delegator_token

    - name: Configure K8S Auth Method
      hashivault_k8s_auth_config:
        url: "{{ vault_url }}"
        username: "{{ vault_username }}"
        password: "{{ vault_password }}"
        authtype: "userpass"
        mount_point: "{{ cluster_name }}"
        kubernetes_host: "https://api.{{ cluster_name }}.{{ base_domain }}:6443"
        kubernetes_ca_cert: "{{ lookup('file', 'ca.crt') }}"
        token_reviewer_jwt: "{{ auth_delegator_token.stdout }}"
